#include <stdexcept>
#include "arrayIntList.h"
using namespace std;

ArrayIntList::ArrayIntList() {
    this->theArray = new int[10];
    this->size = 0;
    this->capacity = 10;
}

ArrayIntList::ArrayIntList(ArrayIntList& toCopy) {
    this->size = toCopy.size;
    this->capacity = toCopy.capacity;
    this->theArray = new int[this->capacity];
    for (int i=0; i<this->size; i++) {
        this->theArray[i] = toCopy.theArray[i];
    }
}

ArrayIntList::~ArrayIntList() {
    delete[] this->theArray;
}

int ArrayIntList::getSize() {
    return this->size;
}

bool ArrayIntList::isEmpty() {
    return this->size == 0;
}

int ArrayIntList::peekHead() {
    if (this->size == 0) {
        throw runtime_error("ArrayIntList::peekHead, list is empty");
    } else {
        return this->theArray[0];
    }
}

int ArrayIntList::peekTail() {
    if (this->size == 0) {
        throw runtime_error("ArrayIntList::peekHead, list is empty");
    } else {
        return this->theArray[this->size - 1];
    }
}

int& ArrayIntList::at(int i) {
    if (i < this->size && i >= 0) {
        return this->theArray[i];
    } else {
        throw runtime_error("ArrayIntList::at, is not a valid index.");
    }
}

int& ArrayIntList::operator[](int i) {
    return this->theArray[i];
}

void ArrayIntList::insertAtHead(int value) {
    if (this->size == this->capacity) {
        this->expandCapacity();
    }
    for (int i=this->size-1; i>=0; i--) {
        this->theArray[i+1] = this->theArray[i];
    }
    this->theArray[0] = value;
    this->size++;
}

void ArrayIntList::insertAtTail(int value) {
    if (this->size == this->capacity) {
        this->expandCapacity();
    }
    this->theArray[size] = value;
    this->size++;
}

int ArrayIntList::removeHead() {
    if (this->size == 0) {
        throw runtime_error("ArrayIntList::removeHead, list is empty");
    }
    int tmp = this->theArray[0];
    for (int i=1; i<this->size; i++) {
        this->theArray[i-1] = this->theArray[i];
    }
    this->size--;
    return tmp;
}

int ArrayIntList::removeTail() {  if (this->size == 0) {
        throw runtime_error("ArrayIntList::removeTail, list is empty");
    }
    this->size--;
    return this->theArray[size];
}

void ArrayIntList::expandCapacity() {
    int newCapacity = this->capacity*2;
    int* newArray = new int[newCapacity];
    for (int i=0; i<this->size; i++) {
        newArray[i] = this->theArray[i];
    }
    delete[] this->theArray; // reclaim old memory
    this->theArray = newArray; // make class variable point to new array
    this->capacity = newCapacity;
}

ArrayIntList& ArrayIntList::operator=(const ArrayIntList& toAssign) {
    if (this != &toAssign) {
        delete[] this->theArray;

        this->size = toAssign.size;
        this->capacity = toAssign.capacity;
        this->theArray = new int[this->capacity];
        for (int i=0; i<this->size; i++) {
            this->theArray[i] = toAssign.theArray[i];
        }

    }
    return *this;
}