#ifndef IMPL_CIRCARRAYINTLIST_H
#define IMPL_CIRCARRAYINTLIST_H

#include "list.h"

class CircArrayIntList : public List<int> {
protected:
    int* theArray;
    int size;
    int capacity;
    int startPosition;

    void expandCapacity();

public:
    CircArrayIntList();
    CircArrayIntList(CircArrayIntList &toCopy);
    ~CircArrayIntList();

    int getSize();
    bool isEmpty();
    int peekHead();
    int peekTail();
    int& at(int i);
    int& operator[](int i);
    void insertAtHead(int value);
    void insertAtTail(int value);
    int removeHead();
    int removeTail();
    CircArrayIntList& operator=(const CircArrayIntList& toAssign);
};

#endif //IMPL_CIRCARRAYINTLIST_H