#include <iostream>
#include <ctime>
#include "timingTests.h"
#include "list.h"
#include "arrayIntList.h"
#include "circArrayIntList.h"
using namespace std;

clock_t timingTest1Helper1(int size) {
    // this is a timing test for the copy constructor
    // first we create an ArrayIntList the appropriate size
    ArrayIntList l;
    for (int i=0; i<size; i++) {
        l.insertAtTail(i);
    }
    clock_t start = clock();
    // repeat 5000 times so that the time interval becomes measurable
    // calibrate on your computer so it takes about 100 milliseconds for size=10000
    for (int i=0; i<5000; i++) {
        ArrayIntList copy(l);
    }
    clock_t end = clock();
    return end-start;
}

clock_t timingTest1Helper2(int size) {
    // this is a timing test for the copy constructor
    // first we create an ArrayIntList the appropriate size
    CircArrayIntList l;
    for (int i=0; i<size; i++) {
        l.insertAtTail(i);
    }
    clock_t start = clock();
    // use same number of repeats as in timingTest1Helper1
    for (int i=0; i<5000; i++) {
        CircArrayIntList copy(l);
    }
    clock_t end = clock();
    return end-start;
}

void timingTest1() {
    cout << "Running Timing Test 1 with ArrayList." << endl;
    cout << "Size 10000: " << timingTest1Helper1(10000) << " milliseconds" << endl;
    cout << "Size 20000: " << timingTest1Helper1(20000) << " milliseconds" << endl;
    cout << "Size 40000: " << timingTest1Helper1(40000) << " milliseconds" << endl;
    cout << "Size 80000: " << timingTest1Helper1(80000) << " milliseconds" << endl;
    cout << "Running Timing Test 1 with CircArrayList." << endl;
    cout << "Size 10000: " << timingTest1Helper2(10000) << " milliseconds" << endl;
    cout << "Size 20000: " << timingTest1Helper2(20000) << " milliseconds" << endl;
    cout << "Size 40000: " << timingTest1Helper2(40000) << " milliseconds" << endl;
    cout << "Size 80000: " << timingTest1Helper2(80000) << " milliseconds" << endl;
}

void timingTest2() {

}

void timingTest3() {

}

void timingTest4() {

}

void timingTest5() {

}
